Cheapest Palindrome
POJ - 3280
时限: 2000MS 内存: 65536KB 64位IO格式: %I64d & %I64u
已开启划词翻译
问题描述
Keeping track of all the cows can be a tricky task so Farmer John has installed a system to automate it. He has installed on each cow an electronic ID tag that the system will read as the cows pass by a scanner. Each ID tag’s contents are currently a single string with length M (1 ≤ M ≤ 2,000) characters drawn from an alphabet of N (1 ≤ N ≤ 26) different symbols (namely, the lower-case roman alphabet).
Cows, being the mischievous creatures they are, sometimes try to spoof the system by walking backwards. While a cow whose ID is “abcba” would read the same no matter which direction the she walks, a cow with the ID “abcb” can potentially register as two different IDs (“abcb” and “bcba”).
FJ would like to change the cows’s ID tags so they read the same no matter which direction the cow walks by. For example, “abcb” can be changed by adding “a” at the end to form “abcba” so that the ID is palindromic (reads the same forwards and backwards). Some other ways to change the ID to be palindromic are include adding the three letters “bcb” to the begining to yield the ID “bcbabcb” or removing the letter “a” to yield the ID “bcb”. One can add or remove characters at any location in the string yielding a string longer or shorter than the original string.
Unfortunately as the ID tags are electronic, each character insertion or deletion has a cost (0 ≤ cost ≤ 10,000) which varies depending on exactly which character value to be added or deleted. Given the content of a cow’s ID tag and the cost of inserting or deleting each of the alphabet’s characters, find the minimum cost to change the ID tag so it satisfies FJ’s requirements. An empty ID tag is considered to satisfy the requirements of reading the same forward and backward. Only letters with associated costs can be added to a string.
输入
Line 1: Two space-separated integers: N and M
Line 2: This line contains exactly M characters which constitute the initial ID string
Lines 3.. N+2: Each line contains three space-separated entities: a character of the input alphabet and two integers which are respectively the cost of adding and deleting that character.
输出
Line 1: A single line with a single integer that is the minimum cost to change the given name tag.
样例输入
3 4
abcb
a 1000 1100
b 350 700
c 200 800
样例输出
900
提示
If we insert an “a” on the end to get “abcba”, the cost would be 1000. If we delete the “a” on the beginning to get “bcb”, the cost would be 1100. If we insert “bcb” at the begining of the string, the cost would be 350 + 200 + 350 = 900, which is the minimum.
来源
USACO 2007 Open Gold
题意:字串S长M,由N个小写字母构成。欲通过增删字母将其变为回文串,增删特定字母花费不同,求最小花费。
首先分析,增删操作,实际上本质是一样的让这个位置变成回文的,所以我们只需要一个数组cost存下每个字母增删中费用最小的作为代价。
定义dp[i][j]表示字串S中i到j是回文串花费最小代价,有状态转移方程
dp[i][j]=min(dp[i+1][j]+cost[s[i]-‘a’],dp[i][j-1]+cost[s[j]-‘a’]);
if(s[i]==s[j])//如果相等这个位置就不需要代价,向上个地方最小值。
dp[i][j]=min(dp[i][j],dp[i+1][j-1]);
最后注意边界,i从尾开始扫,j从i下一个位置开始。
关于这一点,为什么i从尾开始,而不是头,j每次就是i下一个开始,我又想了很久,最后发现这个问题根本没有意义 (不对于我这种渣渣 有意义 就是太浪费时间)…这里就是利用能使用动态规划前提存在能被构造的子结构,相当于从已经推出i到j,到更大的i-1,j+1,只是分治的思想,当然i也可以从头开始向尾推,j就变成从i-1,向前推。代码如下
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
int N,M,dp[2200][2200],cost[26];
char s[2020];
int main()
{
while(~scanf("%d %d",&N,&M))
{
scanf("%s",s);
getchar();
for(int i=0;i<N;i++)
{
char c;int a,b;
scanf("%c %d %d",&c,&a,&b);
getchar();
cost[c-'a']=min(a,b);
}
memset(dp,0,sizeof(dp));
for(int i=M-1;i>=0;--i)
for(int j=i+1;j<M;++j)
{
dp[i][j]=min(dp[i+1][j]+cost[s[i]-'a'],dp[i][j-1]+cost[s[j]-'a']);
if(s[i]==s[j])
dp[i][j]=min(dp[i][j],dp[i+1][j-1]);
}
printf("%d\n",dp[0][M-1]);
}
return 0;
}
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
int N,M,dp[2200][2200],cost[26];
char s[2020];
int main()
{
while(~scanf("%d %d",&N,&M))
{
scanf("%s",s);
getchar();
for(int i=0;i<N;i++)
{
char c;int a,b;
scanf("%c %d %d",&c,&a,&b);
getchar();
cost[c-'a']=min(a,b);
}
memset(dp,0,sizeof(dp));
for(int i=1;i<M;++i)
for(int j=i-1;j>=0;--j)
{
dp[i][j]=min(dp[i-1][j]+cost[s[i]-'a'],dp[i][j+1]+cost[s[j]-'a']);
if(s[i]==s[j])
dp[i][j]=min(dp[i][j],dp[i-1][j+1]);
}
printf("%d\n",dp[M-1][0]);
}
return 0;
}